From ddcedda706b5f3ccbb7fdc683cb1656157aca5ec Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sat, 2 Dec 2023 12:52:37 +0100
Subject: [PATCH 46/54] feat: add about dialog

---
 lact-gui/src/app/headerbar.rs | 56 ++++++++++++++++++++++++++++++++++-
 lact-gui/src/app/mod.rs       |  2 +-
 2 files changed, 56 insertions(+), 2 deletions(-)

diff --git a/lact-gui/src/app/headerbar.rs b/lact-gui/src/app/headerbar.rs
index 64d21099..f1735622 100644
--- a/lact-gui/src/app/headerbar.rs
+++ b/lact-gui/src/app/headerbar.rs
@@ -1,4 +1,9 @@
 use super::{apply_box::ApplyBox, gpu_selector::GpuSelector};
+use gtk::{
+    gio::ActionEntry,
+    glib::{self, clone, IsA},
+    prelude::{ActionMapExtManual, GtkWindowExt},
+};
 
 #[derive(Debug, Clone)]
 pub struct Headerbar {
@@ -13,7 +18,7 @@ pub struct Headerbar {
 }
 
 impl Headerbar {
-    pub fn new() -> Self {
+    pub fn new(app: &impl IsA<gtk::Application>, root_win: &gtk::ApplicationWindow) -> Self {
         #[cfg(feature = "adw")]
         let container = adw::HeaderBar::builder().show_title(false).build();
 
@@ -25,7 +30,56 @@ impl Headerbar {
         let gpu_selector = GpuSelector::new();
         let apply_box = ApplyBox::new();
 
+        #[cfg(not(feature = "adw"))]
+        let about_dialog = gtk::AboutDialog::builder()
+            .hide_on_close(true)
+            .modal(true)
+            .transient_for(root_win)
+            .program_name("LACT")
+            .icon_name("io.github.lact-linux")
+            .version(std::env!("CARGO_PKG_VERSION"))
+            .license_type(gtk::License::MitX11)
+            .copyright("The LACT Developers")
+            .authors(
+                std::env!("CARGO_PKG_AUTHORS")
+                    .split(':')
+                    .collect::<Vec<&str>>(),
+            )
+            .build();
+
+        #[cfg(feature = "adw")]
+        let about_dialog = adw::AboutWindow::builder()
+            .hide_on_close(true)
+            .modal(true)
+            .transient_for(root_win)
+            .application_name("LACT")
+            .application_icon("io.github.lact-linux")
+            .version(std::env!("CARGO_PKG_VERSION"))
+            .license_type(gtk::License::MitX11)
+            .copyright("The LACT Developers")
+            .developers(
+                std::env!("CARGO_PKG_AUTHORS")
+                    .split(':')
+                    .collect::<Vec<&str>>(),
+            )
+            .build();
+
+        let menu = gtk::gio::Menu::new();
+        menu.append_item(&gtk::gio::MenuItem::new(Some("About"), Some("win.about")));
+
+        root_win.add_action_entries([ActionEntry::builder("about")
+            .activate(clone!(@weak about_dialog => move |_, _, _| {
+                about_dialog.present();
+            }))
+            .build()]);
+
         container.pack_start(&gpu_selector.dropdown);
+        container.pack_end(
+            &gtk::MenuButton::builder()
+                .icon_name("open-menu-symbolic")
+                .menu_model(&menu)
+                .build(),
+        );
         container.pack_end(&apply_box.container);
 
         Self {
diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index 7fda96e2..2f9db1c4 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -90,7 +90,7 @@ impl App {
 
         let root_stack = RootStack::new(&window, system_info, daemon_client.embedded);
 
-        let headerbar = Headerbar::new();
+        let headerbar = Headerbar::new(&application, &window.clone().upcast::<ApplicationWindow>());
 
         #[cfg(feature = "adw")]
         {

